import type { ExecutionResult } from 'graphql';
import { type DocumentNode, type GraphQLSchema } from 'graphql';
import type { SomeExecutionResultWithoutErrors } from '../../lib/graphql.js';
import { type Variables } from '../../lib/graphql.js';
import type { Object$2 } from '../1_Schema/__.js';
import { Schema } from '../1_Schema/__.js';
import type { GlobalRegistry } from '../2_generator/globalRegistry.js';
import type { GraphQLObjectSelection } from '../3_SelectionSet/encode.js';
import type { ApplyInputDefaults, Config, ReturnModeTypeBase, ReturnModeTypeSuccessData } from './Config.js';
import type { DocumentFn } from './document.js';
import type { GetRootTypeMethods } from './RootTypeMethods.js';
export type Client<$Index extends Schema.Index, $Config extends Config> = {
    raw: (document: string | DocumentNode, variables?: Variables, operationName?: string) => Promise<ExecutionResult>;
    rawOrThrow: (document: string | DocumentNode, variables?: Variables, operationName?: string) => Promise<SomeExecutionResultWithoutErrors>;
    document: DocumentFn<$Config, $Index>;
} & GetRootTypeMethods<$Config, $Index>;
interface HookInputDocumentEncode {
    rootIndex: Object$2;
    documentObject: GraphQLObjectSelection;
}
type InputForSchema2<$Name extends GlobalRegistry.SchemaNames> = $Name extends any ? {
    /**
     * @defaultValue 'default'
     */
    name?: $Name;
    schema: URL | string | GraphQLSchema;
    headers?: HeadersInit;
    /**
     * Used internally for several functions.
     *
     * When custom scalars are being used, this runtime schema is used to
     * encode/decode them before/after your application sends/receives them.
     *
     * When using root type field methods, this runtime schema is used to assist how arguments on scalars versus objects
     * are constructed into the sent GraphQL document.
     */
    schemaIndex: Schema.Index;
    returnMode?: ReturnModeTypeBase | (GlobalRegistry.HasSchemaErrors<$Name> extends true ? ReturnModeTypeSuccessData : never);
    hooks?: {
        documentEncode: (input: HookInputDocumentEncode, fn: (input: HookInputDocumentEncode) => GraphQLObjectSelection) => GraphQLObjectSelection;
    };
} : never;
type Create = <$Input extends InputForSchema2<GlobalRegistry.SchemaNames>>(input: $Input) => Client<GlobalRegistry.GetSchemaIndexOptionally<$Input['name']>, ApplyInputDefaults<{
    returnMode: $Input['returnMode'];
}>>;
export declare const create: Create;
export {};
//# sourceMappingURL=client.d.ts.map